--[[
هذه الإضافةُ تُمَكِّنُ من تغيير الحُزمة الصوتية المستخدمة بسرعة.
هي تُوفِّر التنقل السريع بين الحُزْمات الصوتية المُثَبَّتَة.
اسم المُطَوِّر : عبد الكريم بن سعيد.
عضو في مجموعة جيشيو للعرب.
]]
require "import";
import "android.preference.PreferenceManager";
import "java.io.File";
import "java.io.FileInputStream";
import "java.io.FileWriter";
import "com.androlua.LuaUtil";
import "java.lang.String";
import "java.nio.charset.StandardCharsets";

function getResourceId(nameAttribute)
local packageName = service.getPackageName();
local res = service.getResources();
local resId = res.getIdentifier(nameAttribute, "string", packageName);
return resId
end

function activateSoundPackage (soundPackageName)
prefs = PreferenceManager.getDefaultSharedPreferences(this);
edit = prefs.edit();
edit.putString("sound_package", soundPackageName);
edit.commit();
edit.apply();
end

firstSoundPackage = service.getString(getResourceId("value_default"));
soundsPath = service.getLuaExtDir(service.getString(getResourceId("directory_sounds")));
soundPackages = {};
if File(soundsPath, firstSoundPackage).exists() then
table.insert(soundPackages, firstSoundPackage);
end
soundsList = File(soundsPath).list();
soundsMax = #soundsList;
if soundsMax == 0 then
service.speak ("لا توجد لدَيكَ أيَّةُ حزمة صوتية مُثَبَّتة، الرجاء تثبيت حُزْمَات صوتية لاستخدام هذه الإضافة.");
return true;
end
for i = 1, soundsMax do
if File(File(soundsPath, soundsList[i - 1]), "config").exists() then
soundPackages[#soundPackages + 1] = soundsList[i - 1]
else
if soundsList[i - 1] ~= firstSoundPackage then
if not table.find(soundPackages, firstSoundPackage) then
table.insert(soundPackages, firstSoundPackage)
end
File(soundsPath, soundsList[i - 1]).renameTo(File(soundsPath, firstSoundPackage));
end
end
end
latestSoundPackagesPath = service.getLuaExtDir() .. File.separator .. "latestSelectedSoundPackages";
file = File(latestSoundPackagesPath);
if file.exists() then
inputStream = FileInputStream(file);
curIndex = LuaUtil.readAll(inputStream);
curIndex = String(curIndex, StandardCharsets.UTF_8);
curIndex = tostring(curIndex);
curIndex = tonumber(curIndex);
if curIndex == 0 then
curIndex = 1
end
if curIndex > soundsMax then
curIndex = 1
end
found = false;
for index, _ in ipairs(soundPackages) do
if index == curIndex then
found = true;
end
end
if found then
curIndex = curIndex + 1 > soundsMax and 1 or curIndex + 1
end
writer = FileWriter(latestSoundPackagesPath);writer.write(tostring(curIndex));
writer.close();
service.speak(soundPackages[curIndex]);
service.loadSoundPackage(soundPackages[curIndex]);
activateSoundPackage(soundPackages[curIndex]);
else
writer = FileWriter(latestSoundPackagesPath);
writer.write("0");
writer.close();					
service.speak(soundPackages[1]);
service.loadSoundPackage(soundPackages[1]);
activateSoundPackage(soundPackages[1]);
end
return true;